//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sat Jun  9 14:48:41 PDT 2001
// Last Modified: Sat Jun  9 14:48:45 PDT 2001
// Filename:      ...museinfo/examples/all/minrhy.cpp
// Web Address:   http://sig.sapp.org/examples/museinfo/humdrum/minrhy.cpp
// Syntax:        C++; museinfo
//
// Description:   calculates the minimum timebase which is the least common
//                multiple of all rhythms in the file.
//

#include "humdrum.h"


int main(int argc, char** argv) {
   if (argc < 2) {
      cout << "Usage: " << argv[0] << " input-kern-file" << endl;
      exit(1);
   }
   HumdrumFile hfile;
   for (int i=1; i<argc; i++) {
      hfile.clear();
      hfile.read(argv[i]);
      hfile.analyzeRhythm();
      if (argc > 2) {
         cout << argv[i] << ":\t";
      }
      cout << hfile.getMinTimeBase() << "\n";
   }
}


